searchNodes=[{"doc":"Documentation for CodeGen . Examples use CodeGen , module : TemplateModule , options : [ a : 1 , b : :x , c : &quot;abc&quot; ]","ref":"CodeGen.html","title":"CodeGen","type":"module"},{"doc":"Define a named code block for code generation. This macro simply returns its contents such that the source of the expressions inside the block can be dumped by the user into the host's module file.","ref":"CodeGen.html#block/2","title":"CodeGen.block/2","type":"macro"},{"doc":"Get the names of the generated blocks.","ref":"CodeGen.html#block_names/1","title":"CodeGen.block_names/1","type":"function"},{"doc":"Returns the generated blocks as a list of pairs of the form {name, code} , where code is the binary representation of the code.","ref":"CodeGen.html#blocks/1","title":"CodeGen.blocks/1","type":"function"},{"doc":"Dumps the source code of a generated block into the module's file. The new code is added to the end of the module (just before the closing end tag).","ref":"CodeGen.html#dump_source/2","title":"CodeGen.dump_source/2","type":"function"},{"doc":"Displays the generated blocks","ref":"CodeGen.html#show_block/2","title":"CodeGen.show_block/2","type":"function"},{"doc":"Displays the generated blocks","ref":"CodeGen.html#show_blocks/1","title":"CodeGen.show_blocks/1","type":"function"},{"doc":"","ref":"CodeGen.DocumentationOnlyError.html","title":"CodeGen.DocumentationOnlyError","type":"exception"},{"doc":"An exception to be raised when the user tries to invoke a function in a module created for documentation purposes only. When documenting a module that supports CodeGen, the easiest way is often to use CodeGen, ... inside the module itself so that we get an ExDoc page documenting all functions provided by the module. However, we often don't want the user to use thar module directly, as there might be important customizations for which there isn't a good default. An example of a configuration option without a good default is a Gettext module for a Phoenix components library. Users will want to provide their own Gettext module so that the components can be internationalized correctly. This exception is useful if you want to provide a module for documentation purposes only and don't want the functions defined in that module to be used. Example The following code shows an example of how defmodule CrazyFrameworkComponents.CodeGen do @moduledoc false defmacro __code_gen__ ( options ) do # Use this option to control wether functions will be usable or not documentation_only? = Keyword . get ( options , :documentation_only? , false ) raise_if_documentation_only = maybe_raise_not_implemented = if documentation_only? do # This module is documentation only! Raise an exception quote do [ raise ( CodeGen.ModuleForDocumentationOnlyError , unquote ( __CALLER__ . module ) ) ] end else # Don&#39;t generate any code [ ] end quote do CodeGen . block &quot;my_component&quot; do @doc &quot;&quot;&quot; Docs for my component. &quot;&quot;&quot; def my_component ( assigns ) do # Use `unquote_splicing` so that we can convert the empty list to &quot;no code&quot; unquote_splicing ( raise_if_documentation_only ) # Actual code here end end end end end defmodule CrazyFrameworkComponents do @doc &quot;&quot;&quot; The functions in this module are only for documentation purposes. They will raise an error if called &quot;&quot;&quot; # Make it so that users can `use CodeGen, module: CrazyFrameworkComponents` defmacro __code_gen__ ( options ) do quote do require CrazyFrameworkComponents.CodeGen CrazyFrameworkComponents.CodeGen . __code_gen__ ( unquote ( options ) ) end end use module : CrazyFrameworkComponents.CodeGen , options : [ # Generate functions which raise instead of returning the right value documentation_only? : true , # Other options ] end","ref":"CodeGen.DocumentationOnlyError.html#__struct__/0","title":"CodeGen.DocumentationOnlyError.__struct__/0","type":"function"}]